pcr_relay_avr_detect() {

    BAUD_RATES="115200 250000 38400"
    TRIES=3

    TMPFILE=`mktemp`

    FOUND=""
    for PLATFORM_TTY_DEVICE in /sys/class/tty/*; do
        DEVPATH="`readlink -f $PLATFORM_TTY_DEVICE`"
        PCR_RELAY_PORT="`basename "$PLATFORM_TTY_DEVICE"`"
        if [ -c "/dev/$PCR_RELAY_PORT" ] && [ "${DEVPATH##/sys/devices/virtual/}" = "${DEVPATH}" ]; then
            ORIG_MODE="`stty -g </dev/"$PCR_RELAY_PORT"`"
            if [ -n "$ORIG_MODE" ]; then
                for PCR_RELAY_BAUD_RATE in $BAUD_RATES; do
                    if stty </dev/"$PCR_RELAY_PORT" raw ispeed $PCR_RELAY_BAUD_RATE ospeed $PCR_RELAY_BAUD_RATE >/dev/null 2>&1; then
                        TRY="$TRIES"
                        while [ "$TRY" -gt 0 ]; do
                            pcr_relay_query_internal S > "$TMPFILE"
                            if grep -qs '[+]S ' "$TMPFILE"; then
                                PCR_RELAY_PRODUCT=`<"$TMPFILE" grep -o ' id=\([^ ]*\)' | sed -e 's/ id=\([^ ]*\)/\1/g'`
                                PCR_RELAY_VERSION=`<"$TMPFILE" grep -o ' ver=\([^ ]*\)' | sed -e 's/ ver=\([^ ]*\)/\1/g'`
                                if [ -n "$PCR_RELAY_PRODUCT" ] || [ -n "$PCR_RELAY_VERSION" ]; then
                                    FOUND=1
                                    break
                                fi
                            else
                                sleep 1
                                TRY="$(($TRY-1))"
                            fi
                        done
                        if [ -n "$FOUND" ]; then
                            break
                        fi
                    fi
                done
                stty </dev/"$PCR_RELAY_PORT" "$ORIG_MODE"
            fi
        fi
        if [ -n "$FOUND" ]; then
            break
        fi
    done

    if [ -z "$FOUND" ]; then
        PCR_RELAY_PORT=""
        PCR_RELAY_BAUD_RATE=""
        PCR_RELAY_VERSION=""
        PCR_RELAY_PRODUCT=""
    fi

    rm -f "$TMPFILE"
}
