pcr_update_atheros_art () {
    SIZE="`wc -c <"$1"`"
    if dd if=/sys/kernel/debug/ieee80211/phy0/ath9k/eeprom bs="$SIZE" count=1 | cmp "$1"; then
        pcr_success_message 'ART already up-to-date' 'ART ALREADY' 'UP TO DATE'
    elif [ "$PCR_PRESERVE_OVERLAY" != "0" ]; then
        cp "$1" /eeprom.bin
        cat > /etc/uci-defaults/000-install-art <<"EOF"
#!/bin/sh
set -x
ART=`</proc/mtd awk ' { if ($4=="\"__art\"") { print "/dev/"gensub(":","","",$1) } }'`
dd if=$ART of=/tmp/art.bin bs=64k count=1
dd if=/eeprom.bin of=/tmp/art.bin bs=4k seek=1 count=4 conv=notrunc
mtd write /tmp/art.bin __art
fw_setenv bootargs "`fw_printenv -n bootargs |sed 's/,64k@16711680(__art)//g'`"
rm /etc/uci-defaults/000-install-art
rm /tmp/art.bin
rm /eeprom.bin
sync
reboot -f
EOF
        chmod +x /etc/uci-defaults/000-install-art
        fw_setenv bootargs "`fw_printenv -n bootargs |sed 's/mtdparts=[^ ]*/&,64k@16711680(__art)/g'`"
        sync
        pcr_success_message 'ART update configured' 'WILL UPDATE' 'ART'
        PCR_PRESERVE_OVERLAY="1"
        PCR_REQUIRE_REBOOT_ON_SHUTDOWN=1
    else
        pcr_failure_message 'ART update postponed due to conflict' 'ART' 'UPDATE POSTPONED'
    fi
}
